{$FORM TForm2, Unit2.sfm}                                                                           
        
uses
  Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, 
  CAM,                                                    
  CADDocument,                               
  CADFunctions, 
  CADConstants,             
  CommonUtils, 
  CADTypes; 
  
               
var      
     //Macros-variables
     MacroSource: TStringList;    
     
     //MacroFields-variables
     AnschnittfahneInnen,
     AusschnittfahneInnen,
     DInnen,                   
     DAussen,
     AnschnittfahneAussen,                                 
     AusschnittfahneAussen : TFloatType;                             
     Anzahl,  
     Abstand: integer;
     VersatzGesamt: TFloatType;        
     SegmentAnzahl: integer; 
                  
     /////////////////////////////////
                                
     //Program variables                                                   
     Addition: TFloatType;  
     
             
                    
procedure Init;                  
begin
  AnschnittfahneInnen   := StrToFloat(edtAnschnittfahneInnen.Text);
  AusschnittfahneInnen  := StrToFloat(edtAusschnittfahneInnen.Text);                  
  DInnen                := StrToFloat(edtDInnen.Text); 
  DAussen               := StrToFloat(edtDAussen.Text);             
  AnschnittfahneAussen  := StrToFloat(edtAnschnittfahneAussen.Text);
  AusschnittfahneAussen := StrToFloat(edtAusschnittfahneAussen.Text);
  Anzahl                := StrToInt(edtAnzahl.Text); 
  VersatzGesamt         := StrToFloat(edtVersatzGesamt.Text);
  Abstand               := StrToFloat(edtAbstand.Text); 
  SegmentAnzahl         := StrToInt(edtSegmentAnzahl.Text); 
end;                          
                       
procedure Draw;
var  sx, sy, cx, cy, ex, ey: single;
     i, hLine, hCircle, hCircleO : integer;
begin 
  DAussen := DAussen + VersatzGesamt;                        
  DInnen  := DInnen  - VersatzGesamt;
                           
  for i := 0 to Anzahl - 1 do
  begin 
    Addition := (DAussen + Abstand) * i;                                                            
    sx := (DAussen/2) +  ((DInnen /2) - AnschnittfahneInnen)  + Addition;
    sy := (DAussen/2);           
    ex := (DAussen/2) +  ((DInnen /2)) + Addition;
    ey := (DAussen/2);
    hLine := CAD_BlockAddLine(CADDocument.hBlock, sx, sy, ex, ey);
    CAD_PropPutStr(hLine, CAD_PROP_ENT_LAYER, CAM_LAYER_INNER_CONTOUR_CCW);
    cx := (DAussen/2) + Addition;
    cy := (DAussen/2);              
    hCircle := CAD_BlockAddCircle(CADDocument.hBlock, cx, cy, (DInnen/2), 0);
    CAD_PropPutStr(hCircle, CAD_PROP_ENT_LAYER, CAM_LAYER_INNER_CONTOUR_CCW);                                                                     
    CAD_PropPutBool (hCircle, CAD_PROP_CIRCLE_DIRCW, 0); 
    CAD_PropPutFloat (hCircle, CAD_PROP_CIRCLE_ANG0, 0); 
    if(SegmentAnzahl > 0) then
      CAD_EntSplit(hCircle, SegmentAnzahl, 0, 1);

    sx := ex;                               
    sy := ey;                                                                                          
    ex := sx - AusschnittfahneInnen;
    ey := sy - AusschnittfahneInnen; 
    hLine := CAD_BlockAddLine(CADDocument.hBlock, sx, sy, ex, ey);
                                   
    sx := ((DAussen/2) * cos(315 * cuPi / 180)) + (DAussen/2) + AnschnittfahneAussen + AusschnittfahneInnen  + Addition;
    sy := ((DAussen/2) * sin(315 * cuPi / 180))  + (DAussen/2) - AnschnittfahneAussen + AusschnittfahneInnen;                                           
    ex := ((DAussen/2) * cos(315 * cuPi / 180)) + (DAussen/2) + Addition;                  
    ey := ((DAussen/2) * sin(315 * cuPi / 180)) + (DAussen/2);
    hLine := CAD_BlockAddLine(CADDocument.hBlock, sx, sy, ex, ey);
    CAD_PropPutStr(hLine, CAD_PROP_ENT_LAYER, CAM_LAYER_OUTER_CONTOUR_CW);
    
                                                         
    hCircle := CAD_BlockAddCircle(CADDocument.hBlock, cx, cy, (DAussen/2), 0);  
    CAD_PropPutStr(hCircle, CAD_PROP_ENT_LAYER, CAM_LAYER_OUTER_CONTOUR_CW);
    CAD_PropPutBool (hCircle, CAD_PROP_CIRCLE_DIRCW, 1); 
    CAD_PropPutFloat (hCircle, CAD_PROP_CIRCLE_ANG0, (315 * cuPi / 180)); 
    if(SegmentAnzahl > 1) then
      CAD_EntSplit(hCircle, SegmentAnzahl, 0, 1);
    
    sx := ex;                               
    sy := ey;                                                                                          
    ey := sy - AusschnittfahneAussen;  
    hLine := CAD_BlockAddLine(CADDocument.hBlock, sx, sy, ex, ey);
    CAD_PropPutStr(hLine, CAD_PROP_ENT_LAYER, CAM_LAYER_OUTER_CONTOUR_CW);
  end;
  CAD_ZoomRect(CADDocument.hLcWnd, -10, -10, (((DAussen + Abstand) * Anzahl) +10), (DAussen +10)); 
  CAD_Refresh(CADDocument.hLcWnd);  
end;  

procedure Button1Click(Sender: TObject);
begin
  Init;
  Draw;  
end; 

procedure MakeMacro; 
begin  
  MacroSource := TStringList.Create; 
end; 

procedure btnMakeMacroClick(Sender: TObject);
begin
  MakeMacro;          
end;
                                                              
procedure Form2_2_2_1_3_2Create(Sender: TObject);
begin
  MacroSource := nil; 
end; 

procedure btnCancelClick(Sender: TObject);
begin   
  Close;
end;     
               
procedure Form2_2_2_1_3_2Close(Sender: TObject; var Action: TCloseAction);
begin
 if (MacroSource <> nil) then
  begin 
   MacroSource.Free;
   MacroSource := nil; 
  end;     
end;
  
begin             
end.                                         
